/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */

export interface paths {
  "/auth/register": {
    post: {
      responses: {
        /** Account created. */
        201: {
          content: {
            "application/json": {
              token: string;
            };
          };
        };
        /** The email address is already in use. */
        409: unknown;
      };
      requestBody: {
        content: {
          "application/json": {
            /** Format: email */
            email: string;
            password: string;
          };
        };
      };
    };
  };
  "/auth/login": {
    post: {
      responses: {
        /** Login successful. */
        200: {
          content: {
            "application/json": {
              token: string;
            };
          };
        };
        /** Invalid credentials. */
        401: unknown;
      };
      requestBody: {
        content: {
          "application/json": {
            /** Format: email */
            email: string;
            password: string;
          };
        };
      };
    };
  };
  "/auth/request-password-reset": {
    post: {
      responses: {
        /** If an account with the given email exists, an email will be sent to the address with a password reset link. */
        200: unknown;
      };
      requestBody: {
        content: {
          "application/json": {
            /** Format: email */
            email: string;
          };
        };
      };
    };
  };
  "/auth/reset-password": {
    post: {
      responses: {
        /** Password has been reset. */
        200: {
          content: {
            "application/json": {
              token: string;
            };
          };
        };
        /** The token is invalid or has expired. */
        401: unknown;
      };
      requestBody: {
        content: {
          "application/json": {
            password: string;
            token: string;
          };
        };
      };
    };
  };
  "/auth/update-password": {
    post: {
      responses: {
        /** Password has been updated. */
        200: {
          content: {
            "application/json": {
              token: string;
            };
          };
        };
        /** Invalid credentials. */
        401: unknown;
      };
      requestBody: {
        content: {
          "application/json": {
            newPassword: string;
            currentPassword: string;
          };
        };
      };
    };
  };
  "/fields": {
    get: {
      responses: {
        /** An array of the fields you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseField"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
    post: {
      parameters: {
        query: {
          groupId: string;
        };
      };
      responses: {
        /** Successfully created the field. */
        201: {
          content: {
            "application/json": {
              fields: components["schemas"]["ResponseField"][];
              areas: components["schemas"]["ResponseArea"][];
            };
          };
        };
        401: components["responses"]["401"];
      };
      /** The field object to be created. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["PopulatedField"];
        };
      };
    };
  };
  "/fields/{id}": {
    get: {
      parameters: {
        path: {
          /** The id of the field to get. */
          id: string;
        };
      };
      responses: {
        /** The field with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseField"];
          };
        };
        401: components["responses"]["401"];
        /** No field with the given id exists. */
        404: unknown;
      };
    };
    delete: {
      parameters: {
        path: {
          /** The id of the field to delete. */
          id: string;
        };
      };
      responses: {
        /** The field was deleted successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No field with the given id exists. */
        404: unknown;
        /** Cannot delete a field that has resources that depend on it. */
        409: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
    };
    patch: {
      parameters: {
        path: {
          /** The id of the field to edit. */
          id: string;
        };
      };
      responses: {
        /** The field was saved successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No field with the given id exists. */
        404: unknown;
      };
      /** The field object to be updated. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["EditableField"];
        };
      };
    };
  };
  "/fields/owner/{owner}/{id}": {
    get: {
      parameters: {
        path: {
          /** The reference id owner. */
          owner: components["schemas"]["ReferenceIdOwners"];
          /** The reference id. */
          id: string;
        };
      };
      responses: {
        /** An array of fields with the given reference id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseField"][];
          };
        };
        401: components["responses"]["401"];
        /** No field with the given reference id exists. */
        404: unknown;
      };
    };
  };
  "/areas": {
    get: {
      responses: {
        /** An array of the areas you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseArea"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/areas/{areaId}": {
    get: {
      parameters: {
        path: {
          /** The id of the area to get. */
          areaId: string;
        };
      };
      responses: {
        /** The area with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseArea"];
          };
        };
        401: components["responses"]["401"];
        /** No area with the given id exists. */
        404: unknown;
      };
    };
    patch: {
      parameters: {
        path: {
          /** The id of the area to edit. */
          areaId: string;
        };
      };
      responses: {
        /** The area was saved successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No area with the given id exists. */
        404: unknown;
        /** Cannot edit an area that has resources that depend on it. */
        409: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
      /** The area object to be updated. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["EditableArea"];
        };
      };
    };
  };
  "/areas/{areaId}/stratifications": {
    post: {
      parameters: {
        path: {
          /** The id of the area to save the stratification to. */
          areaId: string;
        };
      };
      responses: {
        /** Successfully created the stratification. */
        201: {
          content: {
            "application/json": {
              stratifications: components["schemas"]["ResponseStratification"][];
              locationCollections: components["schemas"]["ResponseLocationCollection"][];
              locations: components["schemas"]["ResponseLocation"][];
            };
          };
        };
        401: components["responses"]["401"];
        /** Area not found. */
        404: unknown;
        /** Cannot create a stratification for an area that already has one. */
        409: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
      /** The stratification object and its location collection object to be saved. */
      requestBody: {
        content: {
          "application/json": {
            stratification: components["schemas"]["Stratification"];
            locationCollection: components["schemas"]["PopulatedLocationCollection"];
          };
        };
      };
    };
  };
  "/areas/stratify": {
    post: {
      responses: {
        /** Successfully processed the stratification jobs. Note: It is possible that some of the jobs were not created successfully. Review the response body for details. */
        201: {
          content: {
            "application/json": components["schemas"]["StratificationJob"][];
          };
        };
        /** The request body was invalid. */
        400: {
          content: {
            "application/json": { [key: string]: unknown };
          };
        };
        /** One or more areas were not found. */
        404: unknown;
      };
      /** The area ids to stratify and a stratification configuration. */
      requestBody: {
        content: {
          "application/json": {
            areaIds: string[];
            stratificationConfig: components["schemas"]["StratificationServiceStratificationConfig"];
            autoApprove?: boolean;
          };
        };
      };
    };
  };
  "/stratifications": {
    get: {
      parameters: {
        query: {
          /** Only return stratifications submitted after this ISO8601 timestamp. */
          submittedAfter?: string;
        };
      };
      responses: {
        /** An array of the stratifications you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseStratification"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/stratifications/{stratificationId}": {
    get: {
      parameters: {
        path: {
          /** The id of the stratification to get. */
          stratificationId: string;
        };
      };
      responses: {
        /** The stratification with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseStratification"];
          };
        };
        401: components["responses"]["401"];
        /** No stratification with the given id exists. */
        404: unknown;
      };
    };
    delete: {
      parameters: {
        path: {
          /** The id of the stratification to delete. */
          stratificationId: string;
        };
        query: {
          /** When true, allows the deletion of stratifications with a related sampling collection. The related sampling collections, sampling and samples will also be deleted. This parameter is disregarded if the stratification being deleted is not a demo stratification. */
          force?: boolean;
        };
      };
      responses: {
        /** The stratification was deleted successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No stratification with the given id exists. */
        404: unknown;
        /** Cannot delete a stratification that has resources that depend on it. */
        409: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
    };
  };
  "/location-collections": {
    get: {
      parameters: {
        query: {
          /** Only return location collections submitted after this ISO8601 timestamp. */
          submittedAfter?: string;
        };
      };
      responses: {
        /** An array of the location collections you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseLocationCollection"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/location-collections/{locationCollectionId}": {
    get: {
      parameters: {
        path: {
          /** The id of the location collection to get. */
          locationCollectionId: string;
        };
      };
      responses: {
        /** The location collection with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseLocationCollection"];
          };
        };
        401: components["responses"]["401"];
        /** No location collection with the given id exists. */
        404: unknown;
      };
    };
  };
  "/location-collections/{locationCollectionId}/sampling-collections": {
    post: {
      parameters: {
        path: {
          /** The id of the location collection the sampling collection relates to. */
          locationCollectionId: string;
        };
      };
      responses: {
        /** Successfully created the sampling collection. */
        201: {
          content: {
            "application/json": {
              samplingCollections: components["schemas"]["ResponseSamplingCollection"][];
              samplings: components["schemas"]["ResponseSampling"][];
              samples: components["schemas"]["ResponseSample"][];
            };
          };
        };
        /** Bad request. */
        400: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
        401: components["responses"]["401"];
      };
      /** The sampling collections object to be saved. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["PopulatedSamplingCollection"];
        };
      };
    };
  };
  "/locations": {
    get: {
      responses: {
        /** An array of the locations you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseLocation"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/locations/{locationId}": {
    get: {
      parameters: {
        path: {
          /** The id of the location to get. */
          locationId: string;
        };
      };
      responses: {
        /** The location with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseLocation"];
          };
        };
        401: components["responses"]["401"];
        /** No location with the given id exists. */
        404: unknown;
      };
    };
  };
  "/samples": {
    get: {
      responses: {
        /** An array of the samples you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseSample"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/samples/{sampleId}": {
    get: {
      parameters: {
        path: {
          /** The id of the sample to get. */
          sampleId: string;
        };
      };
      responses: {
        /** The sample with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseSample"];
          };
        };
        401: components["responses"]["401"];
        /** No sample with the given id exists. */
        404: unknown;
      };
    };
    patch: {
      parameters: {
        path: {
          /** The id of the sample to edit. */
          sampleId: string;
        };
      };
      responses: {
        /** The sample was saved successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No sample with the given id exists. */
        404: unknown;
      };
      /** The sample object to be saved. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["EditableSample"];
        };
      };
    };
  };
  "/samplings": {
    get: {
      responses: {
        /** An array of the samplings you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseSampling"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/samplings/{samplingId}": {
    get: {
      parameters: {
        path: {
          /** The id of the sampling to get. */
          samplingId: string;
        };
      };
      responses: {
        /** The sampling with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseSampling"];
          };
        };
        401: components["responses"]["401"];
        /** No sampling with the given id exists. */
        404: unknown;
      };
    };
  };
  "/sampling-collections": {
    get: {
      parameters: {
        query: {
          /** Only return sampling collections submitted after this ISO8601 timestamp. */
          submittedAfter?: string;
        };
      };
      responses: {
        /** An array of the sampling collections you have access to. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseSamplingCollection"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/sampling-collections/{samplingCollectionId}": {
    get: {
      parameters: {
        path: {
          /** The id of the sampling collection to get. */
          samplingCollectionId: string;
        };
      };
      responses: {
        /** The sampling collection with the given id. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseSamplingCollection"];
          };
        };
        401: components["responses"]["401"];
        /** No sampling collection with the given id exists. */
        404: unknown;
      };
    };
  };
  "/resources": {
    get: {
      responses: {
        /** An object keyed by resource, with values that are arrays containing all the resources of each type you have access to. */
        200: {
          content: {
            "application/json": {
              fields: components["schemas"]["ResponseField"][];
              areas: components["schemas"]["ResponseArea"][];
              stratifications: components["schemas"]["ResponseStratification"][];
              locationCollections: components["schemas"]["ResponseLocationCollection"][];
              locations: components["schemas"]["ResponseLocation"][];
              samples: components["schemas"]["ResponseSample"][];
              samplings: components["schemas"]["ResponseSampling"][];
              samplingCollections: components["schemas"]["ResponseSamplingCollection"][];
            };
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/groups": {
    get: {
      responses: {
        /** An array of groups. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseGroup"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
    post: {
      parameters: {
        query: {
          /** If present, specifies the parent group to create the new group within. If not present, the group will be created without a parent group. */
          parentGroupId?: string;
        };
      };
      responses: {
        /** Successfully created the group. */
        201: {
          content: {
            "application/json": components["schemas"]["ResponseGroup"];
          };
        };
        /** The request body is invalid. */
        400: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
        401: components["responses"]["401"];
        /** A group with the same name already exists in the parent group. */
        409: unknown;
      };
      /** The group to be created. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["CreateGroup"];
        };
      };
    };
  };
  "/groups/{groupId}": {
    delete: {
      parameters: {
        path: {
          /** The id of the group to edit. */
          groupId: string;
        };
      };
      responses: {
        /** The group was deleted successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No group with the given id exists. */
        404: unknown;
        /** Cannot delete a group that has resources in it or in a descendant group. */
        409: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
    };
    patch: {
      parameters: {
        path: {
          /** The id of the group to edit. */
          groupId: string;
        };
      };
      responses: {
        /** The group was saved successfully. */
        204: never;
        /** The request body is invalid. */
        400: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
        401: components["responses"]["401"];
        /** No group with the given id exists. */
        404: unknown;
      };
      /** The group object to be updated. */
      requestBody: {
        content: {
          "application/json": components["schemas"]["PatchGroup"];
        };
      };
    };
  };
  "/groups/{groupId}/memberships": {
    get: {
      parameters: {
        path: {
          /** The id of the group to get memberships for. */
          groupId: string;
        };
      };
      responses: {
        /** An array of memberships. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseMembership"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
    post: {
      parameters: {
        path: {
          /** The id of the group to add the user to. */
          groupId: string;
        };
      };
      responses: {
        /** Successfully created the membership. */
        201: {
          content: {
            "application/json": components["schemas"]["ResponseMembership"][];
          };
        };
        401: components["responses"]["401"];
      };
      /** The user to add to the group. */
      requestBody: {
        content: {
          "application/json": {
            /**
             * Format: email
             * @description The email of the user to add to the group.
             */
            userEmail: string;
          };
        };
      };
    };
  };
  "/groups/{groupId}/memberships/{membershipId}": {
    delete: {
      parameters: {
        path: {
          /** The id of the group the membership is in. */
          groupId: string;
          /** The id of the membership to delete. */
          membershipId: string;
        };
      };
      responses: {
        /** Successfully deleted the membership. */
        204: never;
        401: components["responses"]["401"];
      };
    };
  };
  "/reassign": {
    patch: {
      responses: {
        /** Successfully reassigned the field(s) and its related resources to the group. */
        200: unknown;
        401: components["responses"]["401"];
        /** The field or group was not found. */
        404: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
      /** The id(s) of the field(s) to be reassigned, and the id of the group to reassign to. */
      requestBody: {
        content: {
          "application/json": {
            fieldId: string | string[];
            groupId: string;
          };
        };
      };
    };
  };
  "/users": {
    get: {
      responses: {
        /** A list of all users. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseUser"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/user": {
    get: {
      responses: {
        /** A user. */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseUser"];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/memberships": {
    get: {
      responses: {
        /** A list of memberships belonging to the requesting user */
        200: {
          content: {
            "application/json": components["schemas"]["ResponseMembership"][];
          };
        };
        401: components["responses"]["401"];
      };
    };
  };
  "/api-keys": {
    post: {
      responses: {
        /** Successfully created the API key. */
        201: {
          content: {
            "application/json": components["schemas"]["PostApiKeyResponse"];
          };
        };
        401: components["responses"]["401"];
      };
      requestBody: {
        content: {
          "application/json": {
            label: string;
          };
        };
      };
    };
  };
  "/api-keys/{apiKeyId}": {
    delete: {
      parameters: {
        path: {
          /** The id of the API key to delete. */
          apiKeyId: string;
        };
      };
      responses: {
        /** The API key was deleted successfully. */
        204: never;
        401: components["responses"]["401"];
        /** No API key with the given id exists. */
        404: unknown;
      };
    };
  };
  "/stratification-jobs": {
    get: {
      responses: {
        /** An array of stratification jobs. */
        200: {
          content: {
            "application/json": components["schemas"]["StratificationJob"][];
          };
        };
      };
    };
  };
  "/stratification-jobs/resolve": {
    post: {
      parameters: {
        query: {
          /** A token to authenticate the request. */
          token: string;
        };
      };
      responses: {
        /** The stratification job was successfully resolved. */
        200: unknown;
        /** The stratification job was not found. */
        404: unknown;
        /** The stratification job has already been resolved. */
        409: unknown;
      };
      /** The task id, the task's state and the task's result (or error). */
      requestBody: {
        content: {
          "application/json":
            | components["schemas"]["StratificationServiceStratificationJobSuccess"]
            | components["schemas"]["StratificationServiceStratificationJobFailure"];
        };
      };
    };
  };
  "/stratification-jobs/{id}/close": {
    post: {
      parameters: {
        path: {
          /** The id of the stratification job to close. */
          id: string;
        };
      };
      responses: {
        /** The stratification job was successfully closed. */
        200: unknown;
        /** The stratification job was not found. */
        404: unknown;
        /** The stratification job is already closed or the area associated with the stratification job already has a stratification. */
        409: {
          content: {
            "application/json": components["schemas"]["Error"];
          };
        };
      };
      /** The reason for closing the stratification job. */
      requestBody: {
        content: {
          "application/json": {
            closedReason: "APPROVED" | "REJECTED" | "CANCELLED";
          };
        };
      };
    };
  };
}

export interface components {
  schemas: {
    Address: {
      streetAddress?: string;
      addressLocality?: string;
      addressRegion?: string;
      addressCountry?: string;
      postalCode?: string;
    };
    ContactPoint: {
      telephone?: string;
      email?: string;
      name?: string;
      contactType?: string;
      organization?: string;
    };
    Field: {
      name: string;
      alternateName?: string;
      producerName?: string;
      address?: components["schemas"]["Address"];
      contactPoints?: components["schemas"]["ContactPoint"][];
      /** @description The Area (id) belonging to the field. */
      areas: string[];
      meta?: components["schemas"]["ResourceMeta"];
    };
    ResponseField: {
      name: string;
      alternateName: string;
      producerName?: string;
      address: components["schemas"]["Address"];
      contactPoints: components["schemas"]["ContactPoint"][];
      /** @description The Area (id) belonging to the field. */
      areas: string[];
      meta: components["schemas"]["ResponseResourceMeta"];
      id: string;
    };
    PopulatedField: {
      name: string;
      alternateName?: string;
      producerName?: string;
      address?: components["schemas"]["Address"];
      contactPoints?: components["schemas"]["ContactPoint"][];
      /** @description The Area belonging to the field. */
      areas: components["schemas"]["Area"][];
      meta?: components["schemas"]["ResourceMeta"];
    };
    EditableField: {
      name?: string;
      producerName?: string;
      address?: components["schemas"]["Address"];
      contactPoints?: components["schemas"]["ContactPoint"][];
    };
    AreaProperties: {
      name?: string;
      description?: string;
      drawn?: boolean;
    };
    EditableAreaProperties: {
      name?: string;
      description?: string;
    };
    ResponseAreaProperties: {
      name?: string;
      description?: string;
      drawn?: boolean;
      /** @description The Field (id) that the area belongs to. */
      featureOfInterest?: string;
    };
    Area: {
      /** @default Feature */
      type?: "Feature";
      geometry:
        | components["schemas"]["Polygon"]
        | components["schemas"]["MultiPolygon"];
      properties?: components["schemas"]["AreaProperties"];
    };
    ResponseArea: {
      id: string;
      /** @default Feature */
      type: "Feature";
      geometry:
        | components["schemas"]["Polygon"]
        | components["schemas"]["MultiPolygon"];
      properties: components["schemas"]["ResponseAreaProperties"];
      meta: components["schemas"]["ResponseResourceMetaNoRefIds"];
    };
    EditableArea: {
      /** @default Feature */
      type?: "Feature";
      geometry?:
        | components["schemas"]["Polygon"]
        | components["schemas"]["MultiPolygon"];
      properties?: components["schemas"]["EditableAreaProperties"];
    };
    Polygon: {
      /** @default Polygon */
      type: "Polygon";
      coordinates: components["schemas"]["Position"][][];
    };
    MultiPolygon: {
      /** @default MultiPolygon */
      type: "MultiPolygon";
      coordinates: components["schemas"]["Position"][][][];
    };
    Position: number[];
    Point: {
      /** @default Point */
      type: "Point";
      coordinates: components["schemas"]["Position"];
    };
    ResourceMeta: {
      referenceIds?: components["schemas"]["ResourceReferenceIds"];
    };
    ResponseResourceMeta: {
      referenceIds?: components["schemas"]["ResourceReferenceIds"];
      groupId?: string;
      /** Format: date-time */
      submittedAt?: string;
    };
    ResponseResourceMetaNoRefIds: {
      groupId?: string;
      /** Format: date-time */
      submittedAt?: string;
    };
    ResourceReferenceIds: {
      owner: components["schemas"]["ReferenceIdOwners"];
      id: string;
    }[];
    ReferenceIdOwners:
      | "surveystack"
      | "heartland"
      | "soilstack-draft"
      | "carbofarm"
      | "flurosense-field"
      | "flurosense-producer"
      | "flurosense-program"
      | "flurosense-year"
      | "holganix"
      | "holganix-company"
      | "holganix-farm"
      | "holganix-name";
    Algorithm: {
      name?: string;
      alternateName?: string;
      codeRepository?: string;
      version?: string;
      doi?: string;
    };
    Stratification: {
      name: string;
      agent: string;
      /** Format: date-time */
      dateCreated: string;
      provider: string;
      isDemo?: boolean;
      algorithm: components["schemas"]["Algorithm"];
      input?: components["schemas"]["StratificationInput"][];
      result?: components["schemas"]["StratificationResult"][];
    };
    StratificationInput: {
      name?: string;
      value?: unknown;
    };
    StratificationResult: {
      name?: string;
      value?: unknown;
    };
    ResponseStratification: {
      id: string;
      name: string;
      agent: string;
      /** Format: date-time */
      dateCreated: string;
      provider: string;
      isDemo: boolean;
      algorithm: components["schemas"]["Algorithm"];
      input: components["schemas"]["StratificationInput"][];
      result: components["schemas"]["StratificationResult"][];
      /** @description The Field (id) that the area referenced by the stratification belongs to. */
      featureOfInterest: string;
      /** @description The Area (id) that the stratification was performed on. */
      object: string;
      meta: components["schemas"]["ResponseResourceMetaNoRefIds"];
    };
    LocationCollection: {
      /** @description The Area (id) the location collection is in. */
      object: string;
      /** @description The Stratification (id) the location collection belongs to. */
      resultOf?: string;
      /** @description The Field (id) that the location collection is in. */
      featureOfInterest: string;
      /** @description The Locations (ids) belonging to the location collection. */
      features: string[];
    };
    ResponseLocationCollection: {
      id: string;
      /** @description The Area (id) the location collection is in. */
      object: string;
      /** @description The Stratification (id) the location collection belongs to. */
      resultOf: string;
      /** @description The Field (id) that the location collection is in. */
      featureOfInterest: string;
      /** @description The Locations (ids) belonging to the location collection. */
      features: string[];
      meta: components["schemas"]["ResponseResourceMetaNoRefIds"];
    };
    PopulatedLocationCollection: {
      /** @description The Locations belonging to the location collection. */
      features: components["schemas"]["Location"][];
    };
    Location: {
      /** @default Feature */
      type?: "Feature";
      geometry: components["schemas"]["Point"];
      properties?: { [key: string]: unknown };
    };
    ResponseLocation: {
      id: string;
      /** @default Feature */
      type?: "Feature";
      geometry: components["schemas"]["Point"];
      properties?: { [key: string]: unknown };
      meta: components["schemas"]["ResponseResourceMetaNoRefIds"];
    };
    SoDepthValue: {
      value: number;
      unit: "unit:CM";
    };
    SoDepth: {
      minValue: components["schemas"]["SoDepthValue"];
      maxValue: components["schemas"]["SoDepthValue"];
    };
    Sample: {
      name: string;
      soDepth: components["schemas"]["SoDepth"];
    };
    ResponseSample: {
      id: string;
      name: string;
      soDepth: components["schemas"]["SoDepth"];
      /** @description The Sampling the sample belongs to. */
      resultOf: string;
      /** @description The Field the sample was taken in. */
      sampleOf: string;
      meta: components["schemas"]["ResponseResourceMetaNoRefIds"];
    };
    EditableSample: {
      name?: string;
      soDepth?: components["schemas"]["SoDepth"];
    };
    Sampling: {
      /** Format: date-time */
      resultTime: string;
      geometry: components["schemas"]["Point"];
      /** @description The Location (id) this sampling was created at. */
      featureOfInterest: string;
      /** @description The Samples (ids) belonging to the sampling. */
      results?: string[];
      comment?: string;
      procedures?: string[];
      properties?: { [key: string]: unknown };
      soDepth: components["schemas"]["SoDepth"];
    };
    ResponseSampling: {
      id: string;
      /** Format: date-time */
      resultTime: string;
      geometry: components["schemas"]["Point"];
      /** @description The Location (id) this sampling was created at. */
      featureOfInterest: string;
      /** @description The Samples (ids) belonging to the sampling. */
      results: string[];
      comment: string;
      procedures: string[];
      properties: { [key: string]: unknown };
      soDepth: components["schemas"]["SoDepth"];
      /** @description The Sampling Collection (id) this sampling belongs to. */
      memberOf: string;
      meta: components["schemas"]["ResponseResourceMetaNoRefIds"];
    };
    PopulatedSampling: {
      /** Format: date-time */
      resultTime: string;
      geometry: components["schemas"]["Point"];
      /** @description The Location (id) this sampling was created at. */
      featureOfInterest: string;
      /** @description The Samples belonging to the sampling. */
      results?: components["schemas"]["Sample"][];
      comment?: string;
      procedures?: string[];
      properties?: { [key: string]: unknown };
      soDepth: components["schemas"]["SoDepth"];
    };
    SamplingCollection: {
      name?: string;
      /** @description The Samplings (ids) belonging to the sampling collection. */
      members?: string[];
      soDepth: components["schemas"]["SoDepth"];
      sampleDepths: components["schemas"]["SoDepth"][];
      /** Format: date-time */
      dateCreated: string;
      /** Format: date-time */
      dateModified: string;
      meta?: components["schemas"]["ResourceMeta"];
    };
    ResponseSamplingCollection: {
      name: string;
      /** @description The Samplings (ids) belonging to the sampling collection. */
      members: string[];
      soDepth: components["schemas"]["SoDepth"];
      sampleDepths: components["schemas"]["SoDepth"][];
      /** Format: date-time */
      dateCreated: string;
      /** Format: date-time */
      dateModified: string;
      meta: components["schemas"]["ResponseResourceMeta"];
      id: string;
      /** @description The Field (id) the sampling collection was created in. */
      featureOfInterest: string;
      /** @description The Location Collection (id) the sampling collection was derived from. */
      object: string;
    };
    PopulatedSamplingCollection: {
      name?: string;
      /** @description The Samplings belonging to the sampling collection. */
      members?: components["schemas"]["PopulatedSampling"][];
      soDepth: components["schemas"]["SoDepth"];
      sampleDepths: components["schemas"]["SoDepth"][];
      /** Format: date-time */
      dateCreated: string;
      /** Format: date-time */
      dateModified: string;
      meta?: components["schemas"]["ResourceMeta"];
    };
    ResponseGroup: {
      id: string;
      name?: string;
      path: string;
      apiOnly?: boolean;
      meta?: {
        /** Format: date-time */
        submittedAt?: string;
      };
    };
    CreateGroup: {
      name: string;
      apiOnly?: boolean;
    };
    PatchGroup: {
      name?: string;
      apiOnly?: boolean;
    };
    Error: {
      message?: string;
    };
    ResponseUser: {
      id: string;
      /** Format: email */
      email: string;
      seen: boolean;
      apiKeys: components["schemas"]["ApiKey"][];
    };
    ResponseMembership: {
      id: string;
      groupId: string;
      role: string;
      user: {
        id?: string;
        /** Format: email */
        email?: string;
        seen?: boolean;
      };
    };
    ApiKey: {
      id: string;
      label: string;
    };
    PostApiKeyResponse: {
      id: string;
      label: string;
      apiKey: string;
    };
    StratificationJob: {
      id: string;
      areaId: string;
      error?: string;
      isClosed: boolean;
      closedReason?:
        | "APPROVED"
        | "CANCELLED"
        | "REJECTED"
        | "TIMED_OUT"
        | "FAILED_TO_CREATE";
      externalJobStatus?: "PENDING" | "SUCCESS" | "FAILURE";
      jobResult?: components["schemas"]["StratificationServiceStratification"];
      autoApprove: boolean;
      stratificationConfig: string;
      stratificationId?: string;
      /** Format: date-time */
      createdAt: string;
      /** Format: date-time */
      updatedAt: string;
    };
    StratificationServiceArea: {
      /** @default Feature */
      type?: "Feature";
      geometry:
        | components["schemas"]["StratificationServicePolygon"]
        | components["schemas"]["StratificationServiceMultiPolygon"];
      properties?: { [key: string]: unknown };
    };
    StratificationServicePosition: number[];
    StratificationServicePolygon: {
      /** @default Polygon */
      type: "Polygon";
      coordinates: components["schemas"]["StratificationServicePosition"][][];
    };
    StratificationServiceMultiPolygon: {
      /** @default MultiPolygon */
      type: "MultiPolygon";
      coordinates: components["schemas"]["StratificationServicePosition"][][][];
    };
    /** StratificationConfig */
    StratificationServiceStratificationConfig: {
      /**
       * Inputs
       * @description Input data layers used in stratification process
       */
      inputs: components["schemas"]["StratificationServiceConfigInput"][];
      params: components["schemas"]["StratificationServiceConfigParams"];
    };
    /**
     * Point
     * @description Point Model
     */
    StratificationServicePoint: {
      /** Coordinates */
      coordinates: Partial<(Partial<number> & Partial<number>)[]> &
        Partial<(Partial<number> & Partial<number>)[]>;
      /**
       * Type
       * @default Point
       */
      type?: string;
    };
    /**
     * Feature[Point, dict]
     * @description Feature Model
     */
    StratificationServiceFeature_Point__dict_: {
      /**
       * Type
       * @default Feature
       */
      type?: string;
      geometry?: components["schemas"]["StratificationServicePoint"];
      /** Properties */
      properties?: { [key: string]: unknown };
      /** Id */
      id?: string;
      /** Bbox */
      bbox?: Partial<(Partial<number> & Partial<number>)[]> &
        Partial<(Partial<number> & Partial<number>)[]>;
    };
    /** Algorithm */
    StratificationServiceAlgorithm: {
      /** Name */
      name?: string;
      /** Alternatename */
      alternateName?: string;
      /** Coderepository */
      codeRepository?: string;
      /** Version */
      version?: string;
      /** Doi */
      doi?: string;
    };
    /** StratificationInput */
    StratificationServiceStratificationInput: {
      /** Name */
      name: string;
      /** Value */
      value?: unknown;
    };
    /** Result */
    StratificationServiceResult: {
      /** Name */
      name: string;
      /** Value */
      value?: unknown;
    };
    /** Stratification */
    StratificationServiceStratification: {
      /** Locations */
      locations: components["schemas"]["StratificationServiceFeature_Point__dict_"][];
      algorithm: components["schemas"]["StratificationServiceAlgorithm"];
      /** Input */
      input: components["schemas"]["StratificationServiceStratificationInput"][];
      /** Result */
      result: components["schemas"]["StratificationServiceResult"][];
    };
    /**
     * InputParamsSentinel2
     * @description Parameters for Sentinel2 input data layer
     */
    StratificationServiceInputParamsSentinel2: {
      /**
       * Dates
       * @description Date range for stratification process, specified as a string.
       */
      dates?: string;
      /**
       * Masked ratio threshold
       * @description Minimum threshold ratio of valid pixels in each raster for
       *         the raster to be included in analysis, as determined by the Sentinel-2 L2A Scene
       *         Classification Layer (SCL). Rasters are fetched and computed per date, and
       *         discarded if their ratio of pixels classified as "bad" (e.g. cloudy) pixels to
       *         "good" does not meet this value.
       */
      masked_ratio_threshold?: number;
      /**
       * NDVI Maximum
       * @description Maximum allowed NDVI value. Rasters for given dates with NDVI
       *         pixel values greater than this value will be discarded. This prevents
       *         inclusion of bad data. Valid NDVI values should not be greater than 1.0.
       */
      ndvi_max?: number;
      /**
       * Search Query
       * @description STAC catalog search query, defaults to `{"platform": {"eq": "sentinel-2a"}}`
       *         which will include only rasters from Sentinel 2A satellite. Assigning to `{}` will
       *         will include rasters from both Sentinel 2A and 2B satellites. This will result in more
       *          rasters and longer fetching times.
       */
      search_query?: {
        [key: string]: {
          [key: string]: Partial<string> & Partial<number> & Partial<number>;
        };
      };
    };
    /**
     * InputSentinel2
     * @description Sentinel2 satellite input data layer
     */
    StratificationServiceInputSentinel2: {
      /** Source */
      source: "SENTINEL_2";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["StratificationServiceInputParamsSentinel2"];
    };
    /** Empty */
    StratificationServiceEmpty: { [key: string]: unknown };
    /**
     * Input3DEP
     * @description 3DEP elevation input data layer
     */
    StratificationServiceInput3DEP: {
      /** Source */
      source: "3DEP";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["StratificationServiceEmpty"];
    };
    /**
     * InputCopernicus
     * @description Copernicus input data layer
     */
    StratificationServiceInputCopernicus: {
      /** Source */
      source: "COPERNICUS";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["StratificationServiceEmpty"];
    };
    /**
     * InputSSURGO
     * @description SSURGO soil input data layer
     */
    StratificationServiceInputSSURGO: {
      /** Source */
      source: "SSURGO";
      /**
       * Params
       * @default [object Object]
       */
      params?: components["schemas"]["StratificationServiceEmpty"];
    };
    /**
     * ConfigInput
     * @description Input data layer
     */
    StratificationServiceConfigInput:
      | components["schemas"]["StratificationServiceInputSentinel2"]
      | components["schemas"]["StratificationServiceInput3DEP"]
      | components["schemas"]["StratificationServiceInputCopernicus"]
      | components["schemas"]["StratificationServiceInputSSURGO"];
    /**
     * SamplingDensity
     * @description Sampling density configuration
     */
    StratificationServiceSamplingDensity: {
      /**
       * Minimum stratum area
       * @description Lower bound for stratum area to apply this sampling density to.
       *         Specified in hectares.
       */
      min_area: number;
      /**
       * Maximum stratum area
       * @description Upper bound for stratum area to apply this sampling density to.
       *         Specified in hectares
       */
      max_area: number;
      /** Units */
      units: "HECTARES";
      /** Per */
      per: "STRATUM";
      /**
       * Sampling density
       * @description Sampling density, specified as number of samplings (locations)
       *         generated per hectare. E.g. 0.6 (locations per hectare).
       */
      density: number;
      /**
       * Minimum number of samplings
       * @description Lower bound for number of samplings generated by stratification.
       * @default 1
       */
      min_samplings?: number;
      /**
       * Maximum number of samplings
       * @description Upper bound for number of samplings generated by stratification.
       */
      max_samplings?: number;
    };
    /**
     * FieldBoundaryRasterMaskBufferDynamic
     * @description Field boundary raster mask buffer dynamic configuration
     */
    StratificationServiceFieldBoundaryRasterMaskBufferDynamic: {
      /** Type */
      type: "DYNAMIC";
      /**
       * Buffer maximum
       * @description Lower absolute bound for field boundary buffering to remove edge
       *         effects. Specified in negative meters. E.g. -10 (m).
       */
      buffer_max: number;
      /**
       * Buffer minimum
       * @description Upper absolute bound for field boundary buffering to remove edge
       *         effects. Specified in negative meters. E.g. -30 (m).
       */
      buffer_min: number;
      /**
       * Buffer interval
       * @description Step size used to determine optimal field boundary buffering
       *         dynamically. Specified in meters. E.g. 10 (m).
       */
      buffer_interval: number;
      /**
       * Threshold
       * @description Sampleable field area threshold ratio. The underlying calculation
       *         will use the maximum buffer value within bounds (between min and max) while
       *         maintaining a sampleable area ratio greater than this value. Calculated as
       *         `sampleable_area_ratio = buffered_area / field_area`. E.g. 0.6
       */
      threshold: number;
    };
    /** FieldBoundaryRasterMaskBufferStatic */
    StratificationServiceFieldBoundaryRasterMaskBufferStatic: {
      /** Type */
      type: "STATIC";
      /** Value */
      value: number;
    };
    /**
     * NumberOfStrataDynamicParams
     * @description Dynamic number of strata parameters
     */
    StratificationServiceNumberOfStrataDynamicParams: (unknown | unknown) & {
      /**
       * Minimum number of strata
       * @description Lower bound for optimal strata number determination.
       */
      min: number;
      /**
       * Maximum number of strata
       * @description Upper bound for optimal strata number determination.
       */
      max: number;
      /**
       * Dynamic number of strata rate
       * @description Rate (slope) in strata per hectare for center value of optimum
       *         determination. Large values will increase stratification job processing.
       *         time. Alternatively expressed as first member of two item list in `coeffs`
       *         parameter. Either `coeffs` or `rate` and `offset` parameters are required.
       */
      rate?: number;
      /**
       * Dynamic number of strata offset
       * @description Offset (intercept) of strata per hectare for center value of
       *         optimum determination. Alternatively expressed as second member of two item list
       *         in `coeffs` parameter.  Either `coeffs` or `rate` and `offset` parameters are
       *         required.
       */
      offset?: number;
      /**
       * Dynamic number of strata polynomial coefficients
       * @description Coefficients for polynomial strata per hectare center value
       *         of optimum determination. Linear (first degree) polynomials can alternatively be
       *         expressed with `rate` and `offset` parameters. Either `coeffs` or `rate` and
       *         `offset` parameters are required.
       */
      coeffs?: number[];
      /**
       * Minimum geometry area
       * @description Lower bound for geometry area in hectares
       */
      min_area: number;
      /**
       * Maximum geometry area
       * @description Upper bound for geometry area in hectares
       */
      max_area: number;
    };
    /**
     * NumberOfStrataDynamic
     * @description Dynamic number of strata configuration
     */
    StratificationServiceNumberOfStrataDynamic: {
      /** Type */
      type: "DYNAMIC";
      /** Value */
      value: components["schemas"]["StratificationServiceNumberOfStrataDynamicParams"][];
      /**
       * Span
       * @description Dynamic number of strata span about center value (determined by
       *         `rate`). This value is added and subtracted from the value determined by
       *         `rate * area_ha` to determine the range of possible strata values from which to
       *         select an optimum. Note that large values will significantly increase job
       *         processing time.
       */
      span: number;
      /**
       * Padding minimum length
       * @description Minimum length that will be used for padding in determination of
       *         optimal number of strata. At least four strata values are necessary for optimal
       *         value determination. Large values will significantly increase job processing
       *         time
       */
      pad_min_length: number;
    };
    /**
     * NumberOfStrataStatic
     * @description Static number of strata configuration
     */
    StratificationServiceNumberOfStrataStatic: {
      /** Type */
      type: "STATIC";
      /**
       * Value
       * @description Static value for number of strata used in stratification. E.g. 3
       */
      value: number;
    };
    /**
     * ConfigParams
     * @description Stratification configuration parameters
     */
    StratificationServiceConfigParams: {
      /** Sampling Densities */
      sampling_densities: components["schemas"]["StratificationServiceSamplingDensity"][];
      /** Field Boundary Raster Mask Buffer */
      field_boundary_raster_mask_buffer:
        | components["schemas"]["StratificationServiceFieldBoundaryRasterMaskBufferDynamic"]
        | components["schemas"]["StratificationServiceFieldBoundaryRasterMaskBufferStatic"];
      /**
       * Bounding box padding (degrees WGS84)
       * @description Padding applied to bounding box around field boundary. Used
       *         when fetching input data layers for stratification.
       */
      bbox_padding_degrees?: number;
      /**
       * Random seed
       * @description Random seed used for random processes during stratification.
       */
      random_seed?: number;
      /**
       * cLHS maximum iterations
       * @description Number of iterations used in sampling location generation with"
       *         cLHS algorithm. Defaults to 1000. Larger values increase stratification job
       *         time.
       */
      clhs_max_iterations?: number;
      /** N Strata */
      n_strata:
        | components["schemas"]["StratificationServiceNumberOfStrataDynamic"]
        | components["schemas"]["StratificationServiceNumberOfStrataStatic"];
    };
    StratificationServiceStratificationJobSuccess: {
      taskId: string;
      state: "SUCCESS";
      result: components["schemas"]["StratificationServiceStratification"];
    };
    StratificationServiceStratificationJobPending: {
      taskId: string;
      state: "PENDING";
    };
    StratificationServiceStratificationJobFailure: {
      taskId: string;
      state: "FAILURE";
      result: string;
      traceback: string;
    };
  };
  responses: {
    /** Unauthorized */
    401: {
      content: {
        "application/json": { [key: string]: unknown };
      };
    };
  };
}

export interface operations {}

export interface external {}
